apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Parses HTTP Notifications
  name: post-trigger-jenkins-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        pipeline {
            agent any
            options { timeout(time: 5, unit: 'MINUTES') }
            parameters {
{% if clair_api_address | default(False) %}
                string(defaultValue: '{{ clair_api_address | urlsplit('hostname') }}', description: 'Clair Endpoint - Hostname', name: 'clairHost')
                string(defaultValue: '{{ clair_api_address | urlsplit('port') }}', description: 'Clair Endpoint - Port', name: 'clairPort')
                string(defaultValue: '{{ clair_api_address | urlsplit('scheme') }}', description: 'Clair Endpoint - Protocol', name: 'clairProto')
{% elif trivy_api_address | default(False) %}
                string(defaultValue: '{{ trivy_api_address | urlsplit('hostname') }}', description: 'Trivy Endpoint - Hostname', name: 'trivyHost')
                string(defaultValue: '{{ trivy_api_address | urlsplit('port') }}', description: 'Trivy Endpoint - Port', name: 'trivyPort')
                string(defaultValue: '{{ trivy_api_address | urlsplit('scheme') }}', description: 'Trivy Endpoint - Protocol', name: 'trivyProto')
{% else %}
                string(defaultValue: '', description: 'Trivy Endpoint - Hostname', name: 'trivyHost')
                string(defaultValue: '', description: 'Trivy Endpoint - Port', name: 'trivyPort')
                string(defaultValue: '', description: 'Trivy Endpoint - Protocol', name: 'trivyProto')
{% endif %}
                string(defaultValue: 'no', description: 'Has Upstream Component', name: 'hasUpstream')
                string(defaultValue: 'master', description: 'Source Branch', name: 'sourceBranch')
                string(defaultValue: '', description: 'Source Component', name: 'sourceComponent')
                string(defaultValue: '', description: 'ImageStream Name', name: 'sourceImageStream')
                string(defaultValue: 'master', description: 'Source Ref', name: 'sourceRef')
                string(defaultValue: '', description: 'Source Repository', name: 'sourceRepo')
                string(defaultValue: 'master', description: 'Upstream Component Source Branch', name: 'upstreamSourceBranch')
                string(defaultValue: 'apache', description: 'Upstream Component Source Component', name: 'upstreamSourceComponent')
                string(defaultValue: '3', description: 'Max Retry', name: 'jobMaxRetry')
                string(defaultValue: '0', description: 'Retry Count', name: 'jobRetryCount')
                string(defaultValue: 'SUCCESS', description: 'Job Status', name: 'jobStatus')
            }
            stages {
                stage('prost process') {
                    steps {
                        script {
                            openshift.withCluster() {
                                openshift.withProject() {
                                    def jobParams = [:]
                                    def jobNames  = [ ]
                                    def namespace = "${openshift.project()}"
                                    def notifyMsg = ""
                                    currentBuild.description = """
                                    [$params.jobStatus] ${params.sourceRepo} ${params.sourceBranch}
                                    processing ${params.sourceRef}
                                    """.stripIndent()
                                    if (params.jobStatus != 'SUCCESS') {
                                        echo "processing post-failure for ${params.sourceComponent}"
                                        def newCount = params.jobRetryCount.toInteger() + 1
                                        if (params.jobStatus == 'ABORTED') {
                                            notifyMsg = """
                                            Job ${params.sourceComponent} aborted (${params.jobRetryCount}/${params.jobMaxRetry})
                                            Triggered via ${params.sourceRepo} on branch ${params.sourceBranch} ref:${params.sourceRef}
                                            """.stripIndent()
                                        } else {
                                            if (params.jobRetryCount.toInteger() < params.jobMaxRetry.toInteger()) {
                                                notifyMsg = """
                                                Job ${params.sourceComponent} would restart (retry ${newCount} out of ${params.jobMaxRetry})
                                                Triggered via ${params.sourceRepo} on branch ${params.sourceBranch} with previous status ${params.jobStatus}"
                                                """.stripIndent()
                                                jobNames.push(params.sourceComponent)
                                                if (params.hasUpstream != 'no') {
                                                    jobParams[params.sourceComponent] = [
                                                            [$class: 'StringParameterValue', name: "jobMaxRetry", value: params.jobMaxRetry],
                                                            [$class: 'StringParameterValue', name: "jobRetryCount", value: "${newCount}"],
                                                            [$class: 'StringParameterValue', name: "buildBranch", value: params.sourceBranch],
                                                            [$class: 'StringParameterValue', name: "buildHash", value: params.sourceRef],
                                                            [$class: 'StringParameterValue', name: "buildRepo", value: params.sourceRepo],
                                                            [$class: 'StringParameterValue', name: "${params.upstreamSourceComponent}Tag", value: params.upstreamSourceBranch]
                                                        ]
                                                } else {
                                                    jobParams[params.sourceComponent] = [
                                                            [$class: 'StringParameterValue', name: "jobMaxRetry", value: params.jobMaxRetry],
                                                            [$class: 'StringParameterValue', name: "jobRetryCount", value: "${newCount}"],
                                                            [$class: 'StringParameterValue', name: "buildBranch", value: params.sourceBranch],
                                                            [$class: 'StringParameterValue', name: "buildHash", value: params.sourceRef],
                                                            [$class: 'StringParameterValue', name: "buildRepo", value: params.sourceRepo]
                                                        ]
                                                }
                                            } else {
                                                notifyMsg = """
                                                Job ${params.sourceComponent} limit reached (${params.jobRetryCount}/${params.jobMaxRetry})
                                                Triggered via ${params.sourceRepo} on branch ${params.sourceBranch} ref:${params.sourceRef}
                                                """.stripIndent()
                                            }
                                        }
                                    } else {
                                        def add = []
                                        echo "processing post-success for ${params.sourceComponent}"
                                        switch (params.sourceComponent) {
                                            case "apache":
                                                add.add('authproxy');
                                                add.add('lemonldap');
                                                add.add('php');
                                                break;
                                            case "ldap":
                                                //add.add('admin');
                                                break;
                                            case "java":
                                                add.add('csdexporter');
                                                //add.add('elasticsearch');
                                                break;
                                            case "lemon":
                                                //add.add('admin');
                                                break;
                                            case "php":
                                                add.add('dokuwiki');
                                                add.add('fusiondirectory');
                                                add.add('matomo');
                                                add.add('nextcloud');
                                                add.add('whitepages');
                                                add.add('wordpress');
                                                add.add('ssp');
                                                break;
                                            case "node":
                                                add.add('admin');
                                                add.add('chkmgr');
                                                add.add('codimd');
                                                add.add('console');
                                                add.add('etherpad');
                                                add.add('wonit');
                                                break;
                                        }
                                        notifyMsg = """
                                        Job ${params.sourceComponent} succeeded
                                        Triggered via ${params.sourceRepo} on branch ${params.sourceBranch} ref:${params.sourceRef}
                                        """.stripIndent()
                                        for (item in add) {
                                            notifyMsg = """
                                            ${notifyMsg}
                                            - Scheduling job ${item}#${params.sourceBranch} with dependence to ${params.sourceComponent}#${params.sourceBranch}
                                            """.stripIndent()
                                            jobNames.push(item)
                                            jobParams[item] = [
                                                    [$class: 'StringParameterValue', name: "buildBranch", value: params.sourceBranch],
                                                    [$class: 'StringParameterValue', name: "${params.sourceComponent}Tag", value: params.sourceBranch]
                                                ]
                                        }
{% if clair_api_address | default(False) and tekton_scan_images %}
                                        if (params.sourceBranch == 'master' && params.clairHost != '' && params.sourceComponent != '') {
                                            def imageStream = "${params.sourceComponent}"
                                            if (params.sourceImageStream != "") { imageStream = params.sourceImageStream }
                                            def scanImage = "{{ docker_registry }}/${namespace}/${imageStream}:${params.sourceRef}"
                                            notifyMsg = """
                                            ${notifyMsg}
                                            - Scheduling job scanning ${scanImage}
                                            """.stripIndent()
                                            jobNames.push('scan-image-clair')
                                            jobParams['scan-image-clair'] = [
                                                    [$class: 'StringParameterValue', name: "clairHost", value: params.clairHost],
                                                    [$class: 'StringParameterValue', name: "clairPort", value: "${params.clairPort}"],
                                                    [$class: 'StringParameterValue', name: "clairProto", value: params.clairProto],
                                                    [$class: 'StringParameterValue', name: "dockerImage", value: scanImage],
                                                    [$class: 'StringParameterValue', name: "rocketHost", value: params.rocketHost]
                                                ]
                                        }
{% elif tekton_scan_images %}
                                        if (params.sourceBranch == 'master' && params.sourceComponent != '') {
                                            def imageStream = "${params.sourceComponent}"
                                            if (params.sourceImageStream != "") { imageStream = params.sourceImageStream }
                                            def scanImage = "{{ docker_registry }}/${namespace}/${imageStream}:${params.sourceRef}"
                                            notifyMsg = """
                                            ${notifyMsg}
                                            - Scheduling job scanning ${scanImage}
                                            """.stripIndent()
                                            jobNames.push('scan-image-trivy')
                                            jobParams['scan-image-trivy'] = [
                                                    [$class: 'StringParameterValue', name: "trivyHost", value: params.trivyHost],
                                                    [$class: 'StringParameterValue', name: "trivyPort", value: "${params.trivyPort}"],
                                                    [$class: 'StringParameterValue', name: "trivyProto", value: params.trivyProto],
                                                    [$class: 'StringParameterValue', name: "dockerImage", value: scanImage],
                                                    [$class: 'StringParameterValue', name: "rocketHost", value: params.rocketHost]
                                                ]
                                        }
{% endif %}
                                    }
                                    def args
                                    def notifyPost = notifyMsg.replaceAll('"', "'")
                                    echo "${notifyMsg}"
                                    for (iter in jobNames) {
                                        try {
                                            args = jobParams[iter]
                                            build job: "${namespace}/${namespace}-${iter}-jenkins-pipeline", parameters: args, propagate: false, wait: false
                                        } catch(e) { echo "ignoring error / unclear wtf, everything's fine" }
                                    }
                                    try {
                                        withCredentials([usernamePassword(credentialsId: "jenkins-notify-rocket-${params.rocketHost}", usernameVariable: 'RKUSER', passwordVariable: 'RKTOKEN')]) {
                                            def postRocketData = "{\"text\":\"${notifyPost}\",\"channel\":\"@ci-notifications\"}"
                                            try { sh "curl -X POST https://${params.rocketHost}/api/v1/chat.postMessage -d '$postRocketData' -H 'X-Auth-Token: ${RKTOKEN}' -H 'X-User-Id: ${RKUSER}' -H 'Content-type: application/json'" }
                                            catch(e) { echo "In catch block notifying ${params.rocketHost} - ${e}" }
                                        }
                                    } catch(e) { echo "Did not find rocket credentials - would not notify" }
                                    try {
                                        withCredentials([string(credentialsId: "jenkins-notify-slack", variable: 'POST_URI')]) {
                                            def postSlackData = "{ \"text\": \"${notifyPost}\" }"
                                            try { sh "curl -s --data-urlencode 'payload=$postSlackData' 'https://hooks.slack.com/services/${POST_URI}'" }
                                            catch(e) { echo "In catch block notifying slack - ${e}" }
                                        }
                                    } catch(e) { echo "Did not find slack credentials - would not notify" }
                                }
                            }
                        }
                    }
                }
            }
        }
    type: JenkinsPipeline
